<?php
class myDBC{
 
    public $mysqli=null;
 
    public function __construct(){
 
        include_once 'dbconfig.php';
        $this->mysqli = new mysqli(DB_SERVER, DB_USER, DB_PASS, DB_NAME);
 
        if ($this->mysqli->connect_errno){
            echo "Error MySQLi: ("&nbsp. $this->mysqli->connect_errno.") " . $this->mysqli->connect_error;
            exit();
        }
        $this->mysqli->set_charset("utf8");
    }
 
    public function __destruct(){
        $this->CloseDB();
    }
 
    public function runQuery($qry){
		$result = mysqli_query($this->mysqli, $qry);
		if (!$result)
			$result ="Error: " . mysqli_error($this->mysqli);
        return $result;
    }
 
    public function CloseDB(){
        $this->mysqli->close();
    }
	/*
	Aquesta funció rep un codi de barres i cerca aquest codi a les compres per obtenir el "id_article".
	Fa una segona cerca amb aquest id per obtenir l'article.
	*/
	public function article_per_codi($codi_barres){
		$qry = "SELECT * FROM compres WHERE codi_barres LIKE '$codi_barres' LIMIT 1";
		//TODO de moment recull una compra per saber el id_article, en futures versions confirmar que no hi ha més articles amb el mateix codi barres
		$result=$this->runQuery($qry);
		$row = mysqli_fetch_assoc($result);
		$qry = "SELECT * FROM article WHERE id LIKE '".$row["id_article"]."'";
		$result=$this->runQuery($qry);
		$valors = array();
		while($row = mysqli_fetch_assoc($result)){
			 $valors[] = $row;
		}
		return $valors;
	}
	public function compres_per_codi($codi_barres){
		$qry = "SELECT * FROM compres WHERE codi_barres LIKE '$codi_barres' ORDER BY data DESC";
		$result=$this->runQuery($qry);
		$valors = array();
		while($row = mysqli_fetch_assoc($result)){
			 $valors[] = $row;
		}
		return $valors;
	}
	public function compres_per_id_article($id_article){
		$qry = "SELECT * FROM compres WHERE id_article LIKE '$id_article' ORDER BY data DESC";
		$result=$this->runQuery($qry);
		$valors = array();
		while($row = mysqli_fetch_assoc($result)){
			 $valors[] = $row;
		}
		return $valors;
	}
	public function article_per_desc($desc){
		$qry = "SELECT * FROM article WHERE descripcio LIKE '%$desc%'";
		$result=$this->runQuery($qry);
		$valors = array();
		while($row = mysqli_fetch_assoc($result)){
			 $valors[] = $row;
		}
		return $valors;
	}
	public function article_per_id($id_article){
		$qry = "SELECT * FROM article WHERE id LIKE '$id_article'";
		$result=$this->runQuery($qry);
		$row = mysqli_fetch_assoc($result);
		return $row;
	}
	public function inserir_article($id_article, $desc, $stock){
		$qry = "INSERT INTO article (id, descripcio, stock) VALUES ('$id_article', '$desc', '$stock');";
		$result=$this->runQuery($qry);
		return $result;
	}
	public function inserir_compra($id_article,$codi_barres,$data,$proveidor,$oferta,$quantitat,$preu_compra,$preu_impost,$preu_oferta,$preu_venta,$pum,$upum){
		$qry = "INSERT INTO compres(id, id_article, codi_barres, data, proveidor, oferta, quantitat, preu_compra, preu_impost, preu_oferta, preu_venta, pum, upum) VALUES ('','$id_article','$codi_barres', '$data', '$proveidor', '$oferta', '$quantitat', '$preu_compra', '$preu_impost', '$preu_oferta', '$preu_venta', '$pum', '$upum');";
		$result=$this->runQuery($qry);
		return $result;
	}
	public function esborra_article($id){
		$qry = "DELETE FROM article WHERE id='$id'";
		$result=$this->runQuery($qry);
		return $result;
	}
	public function esborra_compra($id){
		$qry = "DELETE FROM compres WHERE id='$id'";
		$result=$this->runQuery($qry);
		return $result;
	}
	public function edita_compra($id_compra,$id_article,$codi_barres,$data,$proveidor,$oferta,$quantitat,$preu_compra,$preu_impost,$preu_oferta,$preu_venta,$pum,$upum){
		$qry = "UPDATE compres SET codi_barres='$codi_barres', data='$data', proveidor='$proveidor', oferta='$oferta', quantitat='$quantitat', preu_compra='$preu_compra', preu_impost='$preu_impost', preu_oferta='$preu_oferta', preu_venta='$preu_venta', pum='$pum', upum='$upum' WHERE id='$id_compra';";
		$result=$this->runQuery($qry);
		return $result;
	}
	public function edita_article($id, $descripcio, $stock, $pof){
		$qry = "UPDATE article SET descripcio='$descripcio', stock='$stock', pof='$pof' WHERE id='$id'";
		$result=$this->runQuery($qry);
		return $result;
	}
	public function mostrar_preu($codi_barres){
		$qry = "SELECT * FROM compres WHERE codi_barres LIKE '$codi_barres' ORDER BY data DESC LIMIT 1";
		$result=$this->runQuery($qry);
		$row = mysqli_fetch_assoc($result);
		$id_article = $row["id_article"];
		
		$qry = "SELECT * FROM compres, article WHERE id_article LIKE '$id_article' AND article.id=compres.id_article ORDER BY data DESC LIMIT 1";
		$result=$this->runQuery($qry);
		$valors = array();
		while($row = mysqli_fetch_assoc($result)){
			//Incluim a l'array el valor del pof obtingut del select de compres
			array_push($row,"pof",$row["pof"]);
			$valors[] = $row;
		}
		
		return $valors;
	}
	public function mostrar_ofertes(){
		$qry = "SELECT * FROM article WHERE pof LIKE true";
		$result=$this->runQuery($qry);
		$valors = array();
		while($row = mysqli_fetch_assoc($result)){
			 $valors[] = $row;
		}
		return $valors;
	}
	
 
}//Fin Clase
?>